//
//  YPCrawlController.h
//  YPCrawler
//
//  Created by Yasir  on 15/01/13.
//  Copyright (c) 2013 YP. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "YPCrawler.h"
@protocol YPCrawlControllerDelegate <NSObject>
-(void) URLCrawlled:(NSString*) url contentSize:(NSInteger) contentSize;
-(void) crawlError;
@end


@interface YPCrawlController : NSObject <YPCrawlerDelegate>
{
	NSMutableArray		*_waitingURLsArray; // array of unique url to crawl
	NSMutableSet		*_crawledURLsSet;   // contain all crawled url as well as checks for duplicate url.
	NSInteger           crawledURLCount;
	NSMutableArray		*_crawlerArray;     // array to hold all crawler which are busy crawling
	NSString			*_baseURL;
}

@property(nonatomic, assign) id delegate;
-(id) initWithBaseURL:(NSString*) baseUrl;
-(void) schedule;
-(void) stop;

@end
