//
//  YPCrawledURLViewController.m
//  YPCrawler
//
//  Created by Yasir  on 21/01/13.
//  Copyright (c) 2013 YP. All rights reserved.
//

#import "YPCrawledURLViewController.h"


const NSString *kURLKey = @"url";
const NSString *kContentSizeKey = @"contentSize";
@interface YPCrawledURLViewController ()

@end

@implementation YPCrawledURLViewController
@synthesize baseURL;

- (id)initWithStyle:(UITableViewStyle)style
{
	return [self initWithStyle:style baseURL:nil];
	
}

- (id)initWithStyle:(UITableViewStyle)style baseURL:(NSString*) bURL {
	
	self = [super initWithStyle:style];
    if (self) {
			// Custom initialization
		self.baseURL = bURL;
		_tableData = [[NSMutableArray alloc] init];
		_crawlController = [[YPCrawlController alloc] initWithBaseURL:bURL];
		_crawlController.delegate = self;
		[self setTitle:@"Crawled URLs"];
    }
    return self;
}

-(void) dealloc {
	if (baseURL) {
		[baseURL release];
		baseURL = nil;
	}
	if(_tableData) {
		[_tableData release];
		_tableData = nil;
	}
	[_crawlController release];
	[super dealloc];
}


- (void)viewDidLoad
{
    [super viewDidLoad];
	[_crawlController schedule];

}

- (void) viewWillDisappear:(BOOL)animated {
	
	[_crawlController stop];
	[super viewWillDisappear:animated];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return [_tableData count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"cellForURLDetails";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
	if(!cell) {
		cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle  reuseIdentifier:CellIdentifier] autorelease];
	}
    
	cell.textLabel.text = [[_tableData objectAtIndex:indexPath.row] objectForKey:kURLKey];
	NSString* contentSizeStr = [NSString stringWithFormat:@"Content Size: %d",[[[_tableData objectAtIndex:indexPath.row] objectForKey:kContentSizeKey] intValue]];
	cell.detailTextLabel.text = contentSizeStr;
    
    return cell;
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{

}
#pragma mark - YPCrawlControllerDelegate

-(void) URLCrawlled:(NSString*) url contentSize:(NSInteger) contentSize {
	NSMutableDictionary *urlDetails = [[[NSMutableDictionary alloc] init] autorelease];
	[urlDetails setObject:url forKey:kURLKey];
	[urlDetails setObject:[NSNumber numberWithInteger:contentSize] forKey:kContentSizeKey];
	
	[_tableData addObject:urlDetails];
	[self.tableView reloadData];
}
-(void) crawlError{
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle: nil
						  message: @"Please check the URL"
						  delegate: nil
						  cancelButtonTitle:@"OK"
						  otherButtonTitles:nil];
	[alert show];
	[alert release];
	
}
@end
