//
//  YPMainViewController.m
//  YPCrawler
//
//  Created by Yasir  on 15/01/13.
//  Copyright (c) 2013 YP. All rights reserved.
//

#import "YPMainViewController.h"
#import "constants.h"
#import "YPCrawledURLViewController.h"

@interface YPMainViewController ()
-(void) crawlAction:(id) sender;
@end

@implementation YPMainViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization

    }
    return self;
}

- (void) dealloc {
	

	[super dealloc];
}

-(void) loadView {
	[super loadView];
	[self setTitle:@"Crawler"];
	
	UITextField *textField =  [[[UITextField alloc] initWithFrame:CGRectMake(kSideMargin, kTopMargin, kButtonNTextFieldWidth, kTextFieldHeight)] autorelease];
	[textField setFont:[UIFont systemFontOfSize:14]];
	[textField setBorderStyle:UITextBorderStyleRoundedRect];
	[textField setTextAlignment:NSTextAlignmentCenter];
	[textField setText:@"http://www.yahoo.com"];
	[textField setPlaceholder:@"Please enter a URL to crawl"];
	[textField setContentVerticalAlignment:UIControlContentVerticalAlignmentCenter];
	[textField setKeyboardType:UIKeyboardTypeURL];
	[textField setAutocapitalizationType:UITextAutocapitalizationTypeNone];
	[textField setClearButtonMode:UITextFieldViewModeWhileEditing];
	[textField setDelegate:self];
	[textField setTag:kTextFieldTag];
	
	[self.view addSubview:textField];
	
	UIButton *crawlButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[crawlButton setFrame:CGRectMake(kSideMargin, (2 *kTopMargin ) + kTextFieldHeight, kButtonNTextFieldWidth, kButtonHeight)];
	[crawlButton setTitle:@"Crawl" forState:UIControlStateNormal];
	[crawlButton addTarget:self action:@selector(crawlAction:) forControlEvents:UIControlEventTouchUpInside];
	
	[self.view addSubview:crawlButton];

}

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (BOOL) validateUrl: (NSString *) url {
	
    NSString *urlRegEx = @"http(s)?://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&amp;=]*)?";
	
    NSPredicate *urlTesting = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", urlRegEx];
    return [urlTesting evaluateWithObject:url];
	
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

#pragma mark -
#pragma mark UITextFieldDelegate
-(BOOL)textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}


#pragma mark -
#pragma mark Button Action

-(void) crawlAction:(id) sender {

	UITextField* textField = (UITextField*)[self.view viewWithTag:kTextFieldTag];
	NSString* url = nil;
	if(textField){
			// validate url
		url = textField.text;
		if(![self validateUrl:url]) {
			UIAlertView *alert = [[UIAlertView alloc]
								  initWithTitle: nil
								  message: @"Please enter a valid URL"
								  delegate: nil
								  cancelButtonTitle:@"OK"
								  otherButtonTitles:nil];
			[alert show];
			[alert release];
			return;
		}
	}
	
	YPCrawledURLViewController *vc = [[YPCrawledURLViewController alloc] initWithStyle:UITableViewStylePlain baseURL:url];

	[self.navigationController pushViewController:vc animated:YES];
	[vc release];
	
}

@end
